package com.yaohun.enderdragonWars.effect;

import com.yaohun.enderdragonWars.Main;
import com.yaohun.enderdragonWars.game.Game;
import org.bukkit.Bukkit;
import org.bukkit.scheduler.BukkitTask;

import java.util.LinkedList;
import java.util.Queue;

public class GiftQueue {

    private Queue<GiftEffect> effectQueue = new LinkedList<>();

    private BukkitTask task;

    public GiftQueue(int waitTime) {
        task = Bukkit.getScheduler().runTaskTimer(Main.plugin, new Runnable() {
            private int timer = 0;
            private boolean running = false;
            @Override
            public void run() {
                timer++;
                if (!running) {
                    timer = waitTime;
                    running = true;
                }
                if (timer >= waitTime) {
                    timer = 0;
                    if (effectQueue.isEmpty()) {
                        running = false;
                        return;
                    }
                    Game game = Main.game;
                    GiftEffect effect = effectQueue.poll();
                    effect.apply(game);
                }
            }
        }, 0L, 1L);
    }

    public void addEffect(GiftEffect effect) {
        effectQueue.add(effect);
    }

    public Queue<GiftEffect> getEffectQueue() {
        return effectQueue;
    }

    public BukkitTask getTask() {
        return task;
    }

}
