package com.yaohun.enderdragonwars.effectevent;

import com.yaohun.enderdragonwars.Main;
import com.yaohun.enderdragonwars.effect.GiftEffect;
import com.yaohun.enderdragonwars.game.Game;
import com.yaohun.enderdragonwars.util.EntityUtil;
import net.kyori.adventure.text.Component;
import org.bukkit.*;
import org.bukkit.block.Block;
import org.bukkit.entity.ArmorStand;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.FallingBlock;
import org.bukkit.entity.Player;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.inventory.EquipmentSlot;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ColorableArmorMeta;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.scheduler.BukkitRunnable;
import org.bukkit.scheduler.BukkitTask;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

public class BomBomEffect extends GiftEffect {

    private static final ItemStack ITEM_1;
    private static final ItemStack ITEM_2;
    private static final ItemStack ITEM_3;
    private static final ItemStack ITEM_4;

    private static final ItemStack ITEM_5;
    private static final ItemStack ITEM_6;
    private static final ItemStack ITEM_7;

    private List<FallingBlock> fallingBlocks = new ArrayList<>();

    protected boolean stop = false;

    public BomBomEffect(String audience) {
        super(audience);
    }

    @Override
    public void apply(Game game) {
        World world = game.getWorld();
        Player player = game.getPlayer();
        ArmorStand armorStand = (ArmorStand) world.spawnEntity(player.getLocation(), EntityType.ARMOR_STAND, CreatureSpawnEvent.SpawnReason.CUSTOM, (entity)->{
            ArmorStand armorStand1 = (ArmorStand) entity;
            armorStand1.setArms(true);
            armorStand1.setBasePlate(false);
            armorStand1.customName(Component.text("§4§l毁天灭地"));
            armorStand1.setCustomNameVisible(true);
            armorStand1.setDisabledSlots(EquipmentSlot.values());
            armorStand1.setInvulnerable(true);
            armorStand1.setGravity(false);
            armorStand1.getEquipment().setItemInMainHand(ITEM_1);
            armorStand1.getEquipment().setItemInOffHand(ITEM_1);
            armorStand1.getEquipment().setItem(EquipmentSlot.HEAD, ITEM_1);
            armorStand1.getEquipment().setItem(EquipmentSlot.CHEST, ITEM_2);
            armorStand1.getEquipment().setItem(EquipmentSlot.LEGS, ITEM_3);
            armorStand1.getEquipment().setItem(EquipmentSlot.FEET, ITEM_4);
        });
        new BukkitRunnable() {
            private int count = 0;
            @Override
            public void run() {
                if (count >= 10) {
                    armorStand.remove();
                    for (int i =0; i < 3; i++) {
                        armorStand.getWorld().createExplosion(armorStand.getLocation(), 5f, true, true);
                    }
                    stop = true;
                    cancel();
                    return;
                }
                Random random = new Random();
                for (int i = 0; i < 30; i++) {
                    FallingBlock fallingBlock = (FallingBlock) world.spawnEntity(armorStand.getLocation(), EntityType.FALLING_BLOCK, CreatureSpawnEvent.SpawnReason.CUSTOM, (fallingBlockEntity)->{
                        FallingBlock fallingBlock1 = (FallingBlock) fallingBlockEntity;
                        fallingBlock1.setBlockData(Bukkit.createBlockData(Material.MAGMA_BLOCK));
                        fallingBlock1.setDropItem(false);
                        fallingBlock1.setCancelDrop(true);
                        fallingBlock1.setFireTicks(200);
                    });
                    fallingBlocks.add(fallingBlock);
                    EntityUtil.shoot(fallingBlock, (Math.random() * 2.5D - 1.5D) * 0.1f, 0.4f + Math.random() * 0.15f, (Math.random() * 2.5D - 1.5D) * 0.1f, 3f + random.nextFloat() * 1.5f, 0f);
                    player.getWorld().playSound(fallingBlock.getLocation(), Sound.ENTITY_GENERIC_EXPLODE, 1f, 1f);
                }
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 15L);
        new BukkitRunnable() {
            private int count = 0;
            @Override
            public void run() {
                if (stop) {
                    cancel();
                    return;
                }
                boolean flag = count % 2 == 0;
                armorStand.customName(Component.text(flag? "§4§l毁天灭地" : "§c§l毁天灭地"));
                armorStand.getEquipment().setItem(EquipmentSlot.CHEST, flag ? ITEM_2 : ITEM_5);
                armorStand.getEquipment().setItem(EquipmentSlot.LEGS,  flag ? ITEM_3 : ITEM_6);
                armorStand.getEquipment().setItem(EquipmentSlot.FEET, flag ? ITEM_4 : ITEM_7);
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 5L);
        new BukkitRunnable() {
            private int count = 0;
            @Override
            public void run() {
                if (stop) {
                    cancel();
                    return;
                }
                float f = count * 25F;
                armorStand.setRotation(f, 0);
                Location location1 = armorStand.getLocation().clone().add(0, 0.35, 0);
                armorStand.getWorld().spawnParticle(Particle.LAVA, location1, 5, 0.2, 0.6, 0.2, 0.05);
                armorStand.getWorld().spawnParticle(Particle.FLAME, location1, 5, 0.2, 1, 0.2, 0.01);
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 2L);
        new BukkitRunnable() {
            private int count = 0;
            @Override
            public void run() {
                if (fallingBlocks.isEmpty()) {
                    cancel();
                    return;
                }
                Iterator<FallingBlock> iterator = fallingBlocks.iterator();
                while (iterator.hasNext()) {
                    FallingBlock fallingBlock = iterator.next();
                    Location location = fallingBlock.getLocation().add(0, -2, 0);
                    Block block = location.getBlock();
                    if (block.getType() != Material.AIR) {
                        location.getWorld().createExplosion(location, 5f, true, true);
                        location.add(0, 1, 0).getBlock().setType(Material.LAVA);
                        fallingBlock.remove();
                        iterator.remove();
                    }
                }
                count++;
            }
        }.runTaskTimer(Main.plugin, 0L, 2L);
    }

    static {
        ITEM_1 = new ItemStack(Material.TNT);
        ITEM_2 = new ItemStack(Material.LEATHER_CHESTPLATE);
        ITEM_3 = new ItemStack(Material.LEATHER_LEGGINGS);
        ITEM_4 = new ItemStack(Material.LEATHER_BOOTS);
        ITEM_5 = new ItemStack(Material.LEATHER_CHESTPLATE);
        ITEM_6 = new ItemStack(Material.LEATHER_LEGGINGS);
        ITEM_7 = new ItemStack(Material.LEATHER_BOOTS);
        Color color1 = Color.fromRGB(214, 41, 0);
        Color color2 = Color.fromRGB(255, 133, 102);
        ItemMeta itemMeta2 = ITEM_2.getItemMeta();
        ColorableArmorMeta colorableArmorMeta2 = (ColorableArmorMeta) itemMeta2;
        colorableArmorMeta2.setColor(color1);
        ITEM_2.setItemMeta(colorableArmorMeta2);
        ItemMeta itemMeta3 = ITEM_3.getItemMeta();
        ColorableArmorMeta colorableArmorMeta3 = (ColorableArmorMeta) itemMeta3;
        colorableArmorMeta3.setColor(color1);
        ITEM_3.setItemMeta(colorableArmorMeta3);
        ItemMeta itemMeta4 = ITEM_4.getItemMeta();
        ColorableArmorMeta colorableArmorMeta4 = (ColorableArmorMeta) itemMeta4;
        colorableArmorMeta4.setColor(color1);
        ITEM_4.setItemMeta(colorableArmorMeta4);
        ItemMeta itemMeta5 = ITEM_5.getItemMeta();
        ColorableArmorMeta colorableArmorMeta5 = (ColorableArmorMeta) itemMeta5;
        colorableArmorMeta5.setColor(color2);
        ITEM_5.setItemMeta(colorableArmorMeta5);
        ItemMeta itemMeta6 = ITEM_6.getItemMeta();
        ColorableArmorMeta colorableArmorMeta6 = (ColorableArmorMeta) itemMeta6;
        colorableArmorMeta6.setColor(color2);
        ITEM_6.setItemMeta(colorableArmorMeta6);
        ItemMeta itemMeta7 = ITEM_7.getItemMeta();
        ColorableArmorMeta colorableArmorMeta7 = (ColorableArmorMeta) itemMeta7;
        colorableArmorMeta7.setColor(color2);
        ITEM_7.setItemMeta(colorableArmorMeta7);

    }

}
