package com.yaohun.enderdragonwars.manager;

import com.yaohun.enderdragonwars.data.GiftData;
import org.bukkit.Bukkit;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.HashMap;
import java.util.Map;

public class GameManager {

    private Map<String, GiftData> giftDataMap = new HashMap<>();

    public GameManager() {
        loadGiftData();
    }

    public void loadGiftData() {
        File file = new File("./plugins/游戏设置", "礼物设置.yml");
        FileConfiguration yml = YamlConfiguration.loadConfiguration(file);
        Bukkit.getConsoleSender().sendMessage("[日志 - 末影龙挑战] 事件注册:");
        ConfigurationSection section = yml.getConfigurationSection("礼物设置");
        if (section == null) {
            System.out.println("[错误 - 游戏] 礼物设置错误,请检查文件.");
            return;
        }
        for (String giftName : section.getKeys(false)) {
            giftDataMap.put(giftName, new GiftData(giftName, yml));
        }
    }

    public Map<String, GiftData> getGiftDataMap() {
        return giftDataMap;
    }

    public GiftData getGiftData(String giftName) {
        if (getGiftDataMap().get(giftName) == null) {
            return null;
        }
        return getGiftDataMap().get(giftName);
    }
}
