package com.yaohun.enderdragonwars;

import com.yaohun.enderdragonwars.effectevent.BomBomEffect;
import com.yaohun.enderdragonwars.game.Game;
import com.yaohun.enderdragonwars.manager.GameManager;
import com.yaohun.enderdragonwars.manager.GiftEffectManager;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import org.jetbrains.annotations.NotNull;

public class Main extends JavaPlugin {

    public static Main plugin;
    public static GameManager gameManager;
    public static Game game;

    @Override
    public void onEnable() {
        plugin = this;
        GiftEffectManager.registerAll();
        gameManager = new GameManager();
        game = new Game();
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (args.length == 1) {
            String subCommand = args[0];
            Player player = (Player) sender;
            game.startGame(player);
            if (subCommand.equalsIgnoreCase("1")) {
                new BomBomEffect(player.getName()).apply(game);
            }
        }
        return true;
    }

    @Override
    public void onDisable() {
        GiftEffectManager.stopQueue();
    }

}
